searchNodes=[{"doc":"The algorithm utilizes symbols to create an internal representation of the world. Each element in the real world is converted into a triple known as a &quot;Working Memory Element&quot; ( Retex.Wme.t() ), represented as {Entity, attribute, attribute_value}. The world is represented through facts (WMEs) and Rules. A Rule consists of two essential parts: the &quot;given&quot; (right side) and the &quot;then&quot; (left side). To perform inference, the rule generates a directed graph starting from a common and generic Root node, which branches out to form leaf nodes. The branches from the Root node correspond to the initial part of the WME, representing the working memory elements or &quot;Entity&quot;. For instance, if we want to represent a customer's account status as &quot;silver&quot;, we would encode it as &quot;{Customer, account_status, silver}&quot;. Alternatively, with the use of a struct, we can achieve the same representation as Retex.Wme.new(&quot;Customer&quot;, &quot;account status&quot;, &quot;silver&quot;) The struct This module also defines a Struct with the following fields: graph: Graph.new() : This field is initialized with the value returned by the Graph.new() function. It is a reference to a directed graph data structure (using libgraph ) that represents a network of interconnected nodes and vertices. wmes: %{} : This field is initialized as an empty map. It is expected to store &quot;working memory elements&quot; (WMEs), which are pieces of information or facts used in the system. agenda: [] : This field is initialized as an empty list. It is intended to store a collection of tasks or items that need to be processed or executed. The agenda typically represents a prioritized queue of pending actions. activations: %{} : This field is initialized as an empty map. It is used to store information related to the activations of nodes in the network. wme_activations: %{} : This field is initialized as an empty map. It is similar to the activations field but specifically focuses on the activations of working memory elements (WMEs) and can serve as reverse lookup of which facts have activated which no. tokens: MapSet.new() : This field is initialized with the value returned by the MapSet.new() function. Will be deprecated soon because it has no use but was a porting from the original paper. bindings: %{} : This field is initialized as an empty map. It is used to store variable bindings or associations between variables and their corresponding values. This can be useful for tracking and manipulating data within the system. pending_activation: [] : This field is initialized as an empty list. It is likely used to keep track of activations that are pending or awaiting further processing. The exact meaning and usage of these pending activations would depend on the system's design.","ref":"Retex.html","title":"Retex","type":"module"},{"doc":"The P node is the production node, just another name of a rule","ref":"Retex.html#add_p_node/4","title":"Retex.add_p_node/4","type":"function"},{"doc":"A production is what is called a Rule in the original Rete paper from C. Forgy A production is a map of given and then and each of those fields contains a list of Retex.Fact.t() which can be tested against a Retex.Wme.t()","ref":"Retex.html#add_production/2","title":"Retex.add_production/2","type":"function"},{"doc":"","ref":"Retex.html#add_token/5","title":"Retex.add_token/5","type":"function"},{"doc":"Takes the network itself and a WME struct and tries to activate as many nodes as possible traversing the graph from the Root until each reachable branch executing a series of &quot;tests&quot; (pattern matching) at each node level. Each node is tested implementing the activation protocol, so to know if how the test for the node against the WME works check their protocol implementation.","ref":"Retex.html#add_wme/2","title":"Retex.add_wme/2","type":"function"},{"doc":"Take each fact of the &quot;given&quot; part of the rule and construct the alpha part of the network destructuring the facts into &quot;Root&quot; -&gt; &quot;Entity&quot; -&gt; &quot;Attribute&quot; -&gt; &quot;Value&quot; (if a node with the same value already exists it will be a noop)","ref":"Retex.html#build_alpha_network/2","title":"Retex.build_alpha_network/2","type":"function"},{"doc":"After building the alpha network we will have a list of nodes which are the bottom of the new subnetwork, not connect those two by two. Take the firs two, join them with a new node, that that one node connect it with the next orphan node, keep doing it until all the facts of a rule are connected together and we have one last &quot;Join&quot; node. And example of a graph with only one &quot;and/join&quot; node: flowchart 2102090852[&quot;==100&quot;] 2332826675[&quot;==silver&quot;] 2833714732[&quot;[{:Discount, :code, 50}]&quot;] 3108351631[&quot;Root&quot;] 3726656564[&quot;Join&quot;] 3801762854[&quot;miles&quot;] 3860425667[&quot;Customer&quot;] 3895425755[&quot;account_status&quot;] 4112061991[&quot;Flight&quot;] 2102090852 --&gt; 3726656564 2332826675 --&gt; 3726656564 3108351631 --&gt; 3860425667 3108351631 --&gt; 4112061991 3726656564 --&gt; 2833714732 3801762854 --&gt; 2102090852 3860425667 --&gt; 3895425755 3895425755 --&gt; 2332826675 4112061991 --&gt; 3801762854","ref":"Retex.html#build_beta_network/2","title":"Retex.build_beta_network/2","type":"function"},{"doc":"","ref":"Retex.html#continue_traversal/4","title":"Retex.continue_traversal/4","type":"function"},{"doc":"","ref":"Retex.html#continue_traversal/5","title":"Retex.continue_traversal/5","type":"function"},{"doc":"","ref":"Retex.html#create_activation/3","title":"Retex.create_activation/3","type":"function"},{"doc":"","ref":"Retex.html#deactivate_descendants/2","title":"Retex.deactivate_descendants/2","type":"function"},{"doc":"","ref":"Retex.html#hash/1","title":"Retex.hash/1","type":"function"},{"doc":"The algorithm utilizes symbols to create an internal representation of the world. Each element in the real world is converted into a triple known as a &quot;Working Memory Element&quot; ( Retex.Wme.t() ), represented as {Entity, attribute, attribute_value}. The world is represented through facts (WMEs) and Rules. A Rule consists of two essential parts: the &quot;given&quot; (right side) and the &quot;then&quot; (left side). To perform inference, the rule generates a directed graph starting from a common and generic Root node, which branches out to form leaf nodes. The branches from the Root node correspond to the initial part of the WME, representing the working memory elements or &quot;Entity&quot;. For instance, if we want to represent a customer's account status as &quot;silver&quot;, we would encode it as &quot;{Customer, account_status, silver}&quot;. Alternatively, with the use of a struct, we can achieve the same representation as Retex.Wme.new(&quot;Customer&quot;, &quot;account status&quot;, &quot;silver&quot;) The struct This module also defines a Struct with the following fields: graph: Graph.new() : This field is initialized with the value returned by the Graph.new() function. It is a reference to a directed graph data structure (using libgraph ) that represents a network of interconnected nodes and vertices. wmes: %{} : This field is initialized as an empty map. It is expected to store &quot;working memory elements&quot; (WMEs), which are pieces of information or facts used in the system. agenda: [] : This field is initialized as an empty list. It is intended to store a collection of tasks or items that need to be processed or executed. The agenda typically represents a prioritized queue of pending actions. activations: %{} : This field is initialized as an empty map. It is used to store information related to the activations of nodes in the network. wme_activations: %{} : This field is initialized as an empty map. It is similar to the activations field but specifically focuses on the activations of working memory elements (WMEs) and can serve as reverse lookup of which facts have activated which no. tokens: MapSet.new() : This field is initialized with the value returned by the MapSet.new() function. Will be deprecated soon because it has no use but was a porting from the original paper. bindings: %{} : This field is initialized as an empty map. It is used to store variable bindings or associations between variables and their corresponding values. This can be useful for tracking and manipulating data within the system. pending_activation: [] : This field is initialized as an empty list. It is likely used to keep track of activations that are pending or awaiting further processing. The exact meaning and usage of these pending activations would depend on the system's design.","ref":"Retex.html#new/0","title":"Retex.new/0","type":"function"},{"doc":"","ref":"Retex.html#propagate_activations/4","title":"Retex.propagate_activations/4","type":"function"},{"doc":"","ref":"Retex.html#propagate_activations/5","title":"Retex.propagate_activations/5","type":"function"},{"doc":"","ref":"Retex.html#replace_bindings/2","title":"Retex.replace_bindings/2","type":"function"},{"doc":"Generate a new Retext.Root.t() struct that represents the first node of the network. An anonymous node that functions just as connector for the type nodes ( Retex.Node.Type.t() )","ref":"Retex.html#root_vertex/0","title":"Retex.root_vertex/0","type":"function"},{"doc":"","ref":"Retex.html#stop_traversal/2","title":"Retex.stop_traversal/2","type":"function"},{"doc":"","ref":"Retex.html#t:action/0","title":"Retex.action/0","type":"type"},{"doc":"","ref":"Retex.html#t:network_node/0","title":"Retex.network_node/0","type":"type"},{"doc":"","ref":"Retex.html#t:t/0","title":"Retex.t/0","type":"type"},{"doc":"Checks which production nodes have been almost activated from the ones with the most activated paths pointing to them, sorted by weak activations.","ref":"Retex.Discovery.html","title":"Retex.Discovery","type":"module"},{"doc":"","ref":"Retex.Discovery.html#weak_activations/1","title":"Retex.Discovery.weak_activations/1","type":"function"},{"doc":"Apply a filter to a variable on the PNode, so that the activation of a PNode happens when this condition is also satisfied","ref":"Retex.Fact.Filter.html","title":"Retex.Fact.Filter","type":"module"},{"doc":"","ref":"Retex.Fact.Filter.html#new/1","title":"Retex.Fact.Filter.new/1","type":"function"},{"doc":"","ref":"Retex.Fact.Filter.html#t:fields/0","title":"Retex.Fact.Filter.fields/0","type":"type"},{"doc":"","ref":"Retex.Fact.Filter.html#t:predicate/0","title":"Retex.Fact.Filter.predicate/0","type":"type"},{"doc":"","ref":"Retex.Fact.Filter.html#t:t/0","title":"Retex.Fact.Filter.t/0","type":"type"},{"doc":"","ref":"Retex.Fact.Filter.html#t:value/0","title":"Retex.Fact.Filter.value/0","type":"type"},{"doc":"","ref":"Retex.Fact.Filter.html#t:variable/0","title":"Retex.Fact.Filter.variable/0","type":"type"},{"doc":"Attribute values that a Wme should have in order for this condition to be true","ref":"Retex.Fact.HasAttribute.html","title":"Retex.Fact.HasAttribute","type":"module"},{"doc":"","ref":"Retex.Fact.HasAttribute.html#new/1","title":"Retex.Fact.HasAttribute.new/1","type":"function"},{"doc":"","ref":"Retex.Fact.HasAttribute.html#t:attribute/0","title":"Retex.Fact.HasAttribute.attribute/0","type":"type"},{"doc":"","ref":"Retex.Fact.HasAttribute.html#t:fields/0","title":"Retex.Fact.HasAttribute.fields/0","type":"type"},{"doc":"","ref":"Retex.Fact.HasAttribute.html#t:owner/0","title":"Retex.Fact.HasAttribute.owner/0","type":"type"},{"doc":"","ref":"Retex.Fact.HasAttribute.html#t:predicate/0","title":"Retex.Fact.HasAttribute.predicate/0","type":"type"},{"doc":"","ref":"Retex.Fact.HasAttribute.html#t:t/0","title":"Retex.Fact.HasAttribute.t/0","type":"type"},{"doc":"","ref":"Retex.Fact.HasAttribute.html#t:value/0","title":"Retex.Fact.HasAttribute.value/0","type":"type"},{"doc":"A type of thing that needs to not exists in order for a Wme to activate part of a condition","ref":"Retex.Fact.IsNot.html","title":"Retex.Fact.IsNot","type":"module"},{"doc":"","ref":"Retex.Fact.IsNot.html#new/1","title":"Retex.Fact.IsNot.new/1","type":"function"},{"doc":"","ref":"Retex.Fact.IsNot.html#t:fields/0","title":"Retex.Fact.IsNot.fields/0","type":"type"},{"doc":"","ref":"Retex.Fact.IsNot.html#t:t/0","title":"Retex.Fact.IsNot.t/0","type":"type"},{"doc":"","ref":"Retex.Fact.IsNot.html#t:type/0","title":"Retex.Fact.IsNot.type/0","type":"type"},{"doc":"","ref":"Retex.Fact.IsNot.html#t:variable/0","title":"Retex.Fact.IsNot.variable/0","type":"type"},{"doc":"A type of thing that needs to exists in order for a Wme to activate part of a condition","ref":"Retex.Fact.Isa.html","title":"Retex.Fact.Isa","type":"module"},{"doc":"","ref":"Retex.Fact.Isa.html#new/1","title":"Retex.Fact.Isa.new/1","type":"function"},{"doc":"","ref":"Retex.Fact.Isa.html#t:fields/0","title":"Retex.Fact.Isa.fields/0","type":"type"},{"doc":"","ref":"Retex.Fact.Isa.html#t:t/0","title":"Retex.Fact.Isa.t/0","type":"type"},{"doc":"","ref":"Retex.Fact.Isa.html#t:type/0","title":"Retex.Fact.Isa.type/0","type":"type"},{"doc":"","ref":"Retex.Fact.Isa.html#t:variable/0","title":"Retex.Fact.Isa.variable/0","type":"type"},{"doc":"Attribute values that a Wme should NOT have in order for this condition to be true","ref":"Retex.Fact.NotExistingAttribute.html","title":"Retex.Fact.NotExistingAttribute","type":"module"},{"doc":"","ref":"Retex.Fact.NotExistingAttribute.html#new/1","title":"Retex.Fact.NotExistingAttribute.new/1","type":"function"},{"doc":"","ref":"Retex.Fact.NotExistingAttribute.html#t:attribute/0","title":"Retex.Fact.NotExistingAttribute.attribute/0","type":"type"},{"doc":"","ref":"Retex.Fact.NotExistingAttribute.html#t:fields/0","title":"Retex.Fact.NotExistingAttribute.fields/0","type":"type"},{"doc":"","ref":"Retex.Fact.NotExistingAttribute.html#t:owner/0","title":"Retex.Fact.NotExistingAttribute.owner/0","type":"type"},{"doc":"","ref":"Retex.Fact.NotExistingAttribute.html#t:t/0","title":"Retex.Fact.NotExistingAttribute.t/0","type":"type"},{"doc":"Attribute values that a Wme should have in order for this condition to be true","ref":"Retex.Fact.Relation.html","title":"Retex.Fact.Relation","type":"module"},{"doc":"","ref":"Retex.Fact.Relation.html#new/1","title":"Retex.Fact.Relation.new/1","type":"function"},{"doc":"A BetaMemory works like a two input node in Rete. It is simply a join node between two tests that have passed successfully. The activation of a BetaMemory happens if the two parents (left and right) have been activated and the bindings are matching for both of them.","ref":"Retex.Node.BetaMemory.html","title":"Retex.Node.BetaMemory","type":"module"},{"doc":"","ref":"Retex.Node.BetaMemory.html#new/1","title":"Retex.Node.BetaMemory.new/1","type":"function"},{"doc":"","ref":"Retex.Node.BetaMemory.html#t:t/0","title":"Retex.Node.BetaMemory.t/0","type":"type"},{"doc":"The NegativeNodeType if part of the alpha network, the discrimination part of the network that check if a specific class DOES NOT exist. If this is the case, it propagates the activations down to the select node types. They will select an attribute and check for its test to pass.","ref":"Retex.Node.NegativeType.html","title":"Retex.Node.NegativeType","type":"module"},{"doc":"","ref":"Retex.Node.NegativeType.html#new/1","title":"Retex.Node.NegativeType.new/1","type":"function"},{"doc":"","ref":"Retex.Node.NegativeType.html#t:t/0","title":"Retex.Node.NegativeType.t/0","type":"type"},{"doc":"Production node. This is like a production node in Rete algorithm. It is activated if all the conditions in a rule are matching and contains the action that can be executed as consequence.","ref":"Retex.Node.PNode.html","title":"Retex.Node.PNode","type":"module"},{"doc":"","ref":"Retex.Node.PNode.html#new/2","title":"Retex.Node.PNode.new/2","type":"function"},{"doc":"","ref":"Retex.Node.PNode.html#t:t/0","title":"Retex.Node.PNode.t/0","type":"type"},{"doc":"The select nodes are checking for attributes, if they exists and are linked to the right owner from above, they will be activated and pass the tokens down in the test nodes (that will check for their value instead).","ref":"Retex.Node.Select.html","title":"Retex.Node.Select","type":"module"},{"doc":"","ref":"Retex.Node.Select.html#new/2","title":"Retex.Node.Select.new/2","type":"function"},{"doc":"","ref":"Retex.Node.Select.html#t:t/0","title":"Retex.Node.Select.t/0","type":"type"},{"doc":"The select nodes are checking for attributes, if they do NOT exists and are linked to the right owner from above, they will be activated and pass the tokens down","ref":"Retex.Node.SelectNot.html","title":"Retex.Node.SelectNot","type":"module"},{"doc":"","ref":"Retex.Node.SelectNot.html#new/2","title":"Retex.Node.SelectNot.new/2","type":"function"},{"doc":"","ref":"Retex.Node.SelectNot.html#t:t/0","title":"Retex.Node.SelectNot.t/0","type":"type"},{"doc":"Test node. If we reached that node, means that we are checking that a value is matching a specific condition. If this is the case, we activate this node and pass the token down to the beta network.","ref":"Retex.Node.Test.html","title":"Retex.Node.Test","type":"module"},{"doc":"","ref":"Retex.Node.Test.html#new/2","title":"Retex.Node.Test.new/2","type":"function"},{"doc":"","ref":"Retex.Node.Test.html#t:t/0","title":"Retex.Node.Test.t/0","type":"type"},{"doc":"The NodeType if part of the alpha network, the discrimination part of the network that check if a specific class exists. If this is the case, it propagates the activations down to the select node types. They will select an attribute and check for its existance.","ref":"Retex.Node.Type.html","title":"Retex.Node.Type","type":"module"},{"doc":"","ref":"Retex.Node.Type.html#new/1","title":"Retex.Node.Type.new/1","type":"function"},{"doc":"","ref":"Retex.Node.Type.html#t:t/0","title":"Retex.Node.Type.t/0","type":"type"},{"doc":"","ref":"Retex.Protocol.Activation.html","title":"Retex.Protocol.Activation","type":"protocol"},{"doc":"This protocol knows how to activate a node and pass the information to children","ref":"Retex.Protocol.Activation.html#activate/5","title":"Retex.Protocol.Activation.activate/5","type":"function"},{"doc":"Implements the strategy to know if a node is activated or not","ref":"Retex.Protocol.Activation.html#active?/2","title":"Retex.Protocol.Activation.active?/2","type":"function"},{"doc":"","ref":"Retex.Protocol.Activation.html#t:t/0","title":"Retex.Protocol.Activation.t/0","type":"type"},{"doc":"","ref":"Retex.Protocol.AlphaNetwork.html","title":"Retex.Protocol.AlphaNetwork","type":"protocol"},{"doc":"This protocol knows how append a new partial production into an existing network based on the type of fact","ref":"Retex.Protocol.AlphaNetwork.html#append/2","title":"Retex.Protocol.AlphaNetwork.append/2","type":"function"},{"doc":"","ref":"Retex.Protocol.AlphaNetwork.html#t:t/0","title":"Retex.Protocol.AlphaNetwork.t/0","type":"type"},{"doc":"The root node is the root vertex of the network. From the root node start all the edges that connect with each TypeNode, the discrimination network starts from here.","ref":"Retex.Root.html","title":"Retex.Root","type":"module"},{"doc":"","ref":"Retex.Root.html#new/0","title":"Retex.Root.new/0","type":"function"},{"doc":"","ref":"Retex.Root.html#t:t/0","title":"Retex.Root.t/0","type":"type"},{"doc":"This serializer converts a Graph to a Mermaid Flowchart .","ref":"Retex.Serializer.html","title":"Retex.Serializer","type":"module"},{"doc":"","ref":"Retex.Serializer.html#vertex_labels/3","title":"Retex.Serializer.vertex_labels/3","type":"function"},{"doc":"The root node of the network is the input to the black box. This node receives the tokens that are sent to the black box and passes copies of the tokens to all its successors. The successors of the top node, the nodes to perform the intra-element tests, have one input and one or more outputs. Each node tests one feature and sends the tokens that pass the test to its successors. The two-input nodes compare tokens from different paths and join them into bigger tokens if they satisfy the inter-element constraints of the LHS. Because of the tests performed by the other nodes, a terminal node will receive only tokens that instantiate the LHS. The terminal node sends out of the black box the information that the conflict set must be changed. - RETE Match Algorithm - Forgy OCR","ref":"Retex.Token.html","title":"Retex.Token","type":"module"},{"doc":"","ref":"Retex.Token.html#new/0","title":"Retex.Token.new/0","type":"function"},{"doc":"","ref":"Retex.Token.html#t:t/0","title":"Retex.Token.t/0","type":"type"},{"doc":"Why a rule was activated? Use this module passing the conclusion of a rule and it will tell you why it was activated","ref":"Retex.Why.html","title":"Retex.Why","type":"module"},{"doc":"","ref":"Retex.Why.html#explain/2","title":"Retex.Why.explain/2","type":"function"},{"doc":"A working memory element, it represent the world in the form of identifier, attribute and values timestamp is set at time of insertion into retex","ref":"Retex.Wme.html","title":"Retex.Wme","type":"module"},{"doc":"","ref":"Retex.Wme.html#new/3","title":"Retex.Wme.new/3","type":"function"},{"doc":"","ref":"Retex.Wme.html#to_has_attribute/1","title":"Retex.Wme.to_has_attribute/1","type":"function"},{"doc":"","ref":"Retex.Wme.html#t:attribute/0","title":"Retex.Wme.attribute/0","type":"type"},{"doc":"","ref":"Retex.Wme.html#t:id/0","title":"Retex.Wme.id/0","type":"type"},{"doc":"","ref":"Retex.Wme.html#t:t/0","title":"Retex.Wme.t/0","type":"type"},{"doc":"","ref":"Retex.Wme.html#t:value/0","title":"Retex.Wme.value/0","type":"type"},{"doc":"","ref":"Retex.Wme.html#t:wme_identifier/0","title":"Retex.Wme.wme_identifier/0","type":"type"},{"doc":"","ref":"changelog.html","title":"tbd","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;{}&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright {yyyy} {name of copyright owner} Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"License","type":"extras"},{"doc":"The Rete Algorithm &quot;The Rete Match Algorithm is an efficient method for comparing a large collection of patterns to a large collection of objects. It finds all the objects that match each pattern. The algorithm was developed for use in production system interpreters, and it has been used for systems containing from a few hundred to more than a thousand patterns and objects&quot; - C. Forgy Boilerplate/PoC of a version of the Rete Algorithm implementated in Elixir Rete is a complex stateful algorithm, this is an attempt of reproducing it with some slight modifications, using a functional immutable language such as Elixir/Erlang. Read more about Rete","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Erlang/OTP 24 Elixir 1.14.2 (compiled with Erlang/OTP 22)","ref":"readme.html#requirements","title":"Overview - Requirements","type":"extras"},{"doc":"The algorithm utilizes symbols to create an internal representation of the world. Each element in the real world is converted into a triple known as a &quot;Working Memory Element&quot; ( Retex.Wme.t() ), represented as {Entity, attribute, attribute_value}. The world is represented through facts (WMEs) and Rules. A Rule consists of two essential parts: the &quot;given&quot; (right side) and the &quot;then&quot; (left side). To perform inference, the rule generates a directed graph starting from a common and generic Root node, which branches out to form leaf nodes. The branches from the Root node correspond to the initial part of the WME, representing the working memory elements or &quot;Entity&quot;. For instance, if we want to represent a customer's account status as &quot;silver&quot;, we would encode it as &quot;{Customer, account_status, silver}&quot;. Alternatively, with the use of a struct, we can achieve the same representation as Retex.Wme.new(&quot;Customer&quot;, &quot;account status&quot;, &quot;silver&quot;). Now, let's explore how this would appear when compiling the rete algorithm with Retex: flowchart 2332826675[==silver] 3108351631[Root] 3860425667[Customer] 3895425755[account_status] 3108351631 --&gt; 3860425667 3860425667 --&gt; 3895425755 3895425755 --&gt; 2332826675 example nr. 1 Now, let's examine the graph, which consists of four nodes in the following order: The Root node This node serves as the root for all type nodes, such as Account, Customer, God, Table, and so on. The Customer node Also known as a Type node, it stores each known &quot;type&quot; of entity recognized by the algorithm. The account_status node Referred to as a Select node, it represents the attribute name of the entity being described. the ==silver node Known as a Test node, it includes the == symbol, indicating that the value of Customer.account_status is checked against &quot;silver&quot; as a literal string (tests can use all Elixir comparison symbols). By expanding this network, we can continue mapping various aspects of the real world using any desired triple. Let's consider the entity representing a Flight, specifically its number of miles. We can represent this as {Flight, miles, 100} to signify a flight with a mileage of 100. Now, let's incorporate this into our network and observe the resulting graph: Let's add this to our network and check what kind of graph we will get: flowchart 2102090852[==100] 2332826675[==silver] 3108351631[Root] 3801762854[miles] 3860425667[Customer] 3895425755[account_status] 4112061991[Flight] 3108351631 --&gt; 3860425667 3108351631 --&gt; 4112061991 3801762854 --&gt; 2102090852 3860425667 --&gt; 3895425755 3895425755 --&gt; 2332826675 4112061991 --&gt; 3801762854 example nr. 2 Now we begin to observe the modeling of more complex scenarios. Let's consider the addition of our first inference to the network, which involves introducing our first rule. The rule we want to encode states that when the Customer's account_status is &quot;silver&quot; and the Flight's miles are exactly &quot;100,&quot; we should apply a discount to the Customer entity. Let's examine how our network will appear after incorporating this rule: flowchart 2102090852[&quot;==100&quot;] 2332826675[&quot;==silver&quot;] 2833714732[&quot;[{:Discount, :code, 50}]&quot;] 3108351631[&quot;Root&quot;] 3726656564[&quot;Join&quot;] 3801762854[&quot;miles&quot;] 3860425667[&quot;Customer&quot;] 3895425755[&quot;account_status&quot;] 4112061991[&quot;Flight&quot;] 2102090852 --&gt; 3726656564 2332826675 --&gt; 3726656564 3108351631 --&gt; 3860425667 3108351631 --&gt; 4112061991 3726656564 --&gt; 2833714732 3801762854 --&gt; 2102090852 3860425667 --&gt; 3895425755 3895425755 --&gt; 2332826675 4112061991 --&gt; 3801762854 Now we have constructed our network, which possesses a symbolic representation of the world and describes the relationships between multiple entities and their values to trigger a rule. Notably, the last node in the graph is represented as {:Discount, :code, 50}. Let's examine how we can interpret this graph step by step: At the first level, we encounter the Root node, which serves as a placeholder. At the second level, we find the Flight and Customer nodes branching out from the Root node. It's important to note that they are at the same level. Both the Flight and Customer nodes branch out only once since they each have only one attribute. Each attribute node (==100 and ==silver) branches out once again to indicate that if we encounter the attribute Customer.account_status, we should verify that its value is indeed &quot;silver.&quot; The last two nodes (==100 and ==silver) both connect to a new anonymous node called the Join node. The Join node branches out only once, leading to the right-hand side of the rule (also known as the production node). This structure of the graph allows us to represent and process complex relationships and conditions within our network.","ref":"readme.html#how-does-it-work","title":"Overview - How does it work?","type":"extras"},{"doc":"Join nodes are also what is called &quot;beta memory&quot; in the original C. Forgy paper. To make it simple we can assert that they group together a set of conditions that need to be true in order for a rule to fire. In our last example, the rule is: # pseudocode given : Flight . miles == 100 and Customer . account_status == &quot;silver&quot; then : Discount . code == 50 In the graph representation, the Join node corresponds to the &quot;and&quot; in the &quot;given&quot; part of the rule. Its purpose is to evaluate and combine the conditions associated with its two parent nodes. Notably, a Join node can only have and will always have exactly two parents (incoming edges), which is a crucial characteristic of its design. By utilizing Join nodes, the network is able to effectively represent complex conditions and evaluate them in order to trigger the corresponding rules.","ref":"readme.html#what-are-join-nodes","title":"Overview - What are join nodes?","type":"extras"},{"doc":"Production nodes, as named in the Forgy paper, refer to the right-hand side of a rule (also known as the &quot;given&quot; part). These nodes are exclusively connected to one incoming Join node in the network. To clarify, the purpose of a production node is to represent the actions or outcomes specified by the rule. It captures the consequences that should occur when the conditions specified in the Join node's associated &quot;given&quot; part are met. This relationship ensures that the rule's right-hand side is only triggered when the conditions of the Join node are satisfied.","ref":"readme.html#what-are-production-nodes","title":"Overview - What are production nodes?","type":"extras"},{"doc":"Once we have a graph like the following and we know how to read it let's imagine we want to use to make inference and so to understand if we can give out such discount code to our customer. flowchart 2102090852[&quot;==100&quot;] 2332826675[&quot;==silver&quot;] 2833714732[&quot;[{:Discount, :code, 50}]&quot;] 3108351631[&quot;Root&quot;] 3726656564[&quot;Join&quot;] 3801762854[&quot;miles&quot;] 3860425667[&quot;Customer&quot;] 3895425755[&quot;account_status&quot;] 4112061991[&quot;Flight&quot;] 2102090852 --&gt; 3726656564 2332826675 --&gt; 3726656564 3108351631 --&gt; 3860425667 3108351631 --&gt; 4112061991 3726656564 --&gt; 2833714732 3801762854 --&gt; 2102090852 3860425667 --&gt; 3895425755 3895425755 --&gt; 2332826675 4112061991 --&gt; 3801762854 This process is called adding WMEs (working memory elements) to the network. As you might have already guessed there is very little difference between a WME and a part of a rule. Retex exposes the function Retex.add_wme(t(), Retex.Wme.t()) which takes the network itself and a WME struct and tries to activate as many nodes as possible traversing the graph from the Root until each reachable branch executing a series of &quot;tests&quot; at each node. Let's see step by step how it would work. Let's rewrite that same graph adding some names to the edges so we can reference them in the description: flowchart 2102090852[&quot;==100&quot;] 2332826675[&quot;==silver&quot;] 2833714732[&quot;[{:Discount, :code, 50}]&quot;] 3108351631[&quot;Root&quot;] 3726656564[&quot;Join&quot;] 3801762854[&quot;miles&quot;] 3860425667[&quot;Customer&quot;] 3895425755[&quot;account_status&quot;] 4112061991[&quot;Flight&quot;] 2102090852 --a--&gt; 3726656564 2332826675 --b--&gt; 3726656564 3108351631 --c--&gt; 3860425667 3108351631 --d--&gt; 4112061991 3726656564 --e--&gt; 2833714732 3801762854 --f--&gt; 2102090852 3860425667 --g--&gt; 3895425755 3895425755 --h--&gt; 2332826675 4112061991 --i--&gt; 3801762854 Let's see what happens when adding the following working memory element to the Retex algorithm Retex.Wme.new(:Flight, :miles, 100 Retex will receive the WME and start testing the network from the Root node which passes down anything as it doesn't test for anything The Root branches out in n nodes (Flight and Customer) the branch d will find a type node with value &quot;Flight&quot; and this is the first part of the WME so the test is passing the next branch from d is i which connects Flight to miles and so we test that the second part of the triple is exactly miles : the test is passing again the next branch from i is f which finds a test node == 100 which is the case of our new WME and so the test is passing next is a which connects to the Join node which needs to be tested: a test for a Join node asserts that all incoming connections are active (their test passed) and given that the branch b is not yet tested the traversal for now ends here and the Join remains only 50% activated the second branch to test is c which connects to Customer and this is not matching Flight so we can't go any further After adding the WME Retex.Wme.new(:Flight, :miles, 100) the only active branches and nodes are d, i, f and a Our rule can't be activated because the parent node Join is not fully active yet and so it can't propagate the current WME to the production node (which is sad but fair) Let's see what happens when adding the following working memory element to the Retex algorithm Retex.Wme.new(:Customer, :account_status, &quot;silver&quot;) Retex will receive the WME and start testing the network from the Root node which passes down anything as it doesn't test for anything The Root branches out in n nodes (Flight and Customer) the branch c will find a type node with value &quot;Customer&quot; and this is the first part of the WME so the test is passing the next branch from c is g which connects Customer to account_status and so we test that the second part of the triple is exactly account_status : the test is passing again the next branch from h finds a test node == &quot;silver&quot; which is the case of our new WME and so the test is passing next is b which connects to the Join node which needs to be tested: a test for a Join node asserts that all incoming connections are active (their test passed) and given that the branch a is also already active (we stored that in a map) we can continue the traversal Now we find a production node which tells us that the Discount code can be applied the second branch to test is d which doesn't match so we can stop the traversal After adding the WME Retex.Wme.new(:Customer, :account_status, &quot;silver&quot;) all nodes are active and so the production node ends up in the agenda (just an elixir list to keep track of all production nodes which are activated) We have now done inference and found an applicable rule. All we need to do now is to add the new WME to the network to check if any other node can be activated in the same way. Now imagine adding more and more complex rules and following the same strategy to find activable production nodes. The conditions will all be joined by a Join (and) node and will point to a production.","ref":"readme.html#how-do-we-use-all-of-that-after-we-built-the-network","title":"Overview - How do we use all of that after we built the network?","type":"extras"},{"doc":"Retex compiles the rules using a directed acyclic graph data structure The activation of nodes is done using a State Monad and Forward Chaining . A list of bindings is stored at each active node in order to generate complete matches from partial ones","ref":"readme.html#concepts","title":"Overview - Concepts","type":"extras"},{"doc":"def deps do [ { :retex , git : &quot;https://github.com/lorenzosinisi/retex&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"If you want you can have a predefined generic DSL and the wrapper NeuralBridge so that you don't have to build the rest of the Expert System from zero # or visit https://neuralbridge.fly.dev &lt;- an online playground to create rules and add facts def deps do [ { :neural_bridge , git : &quot;https://github.com/lorenzosinisi/neural_bridge&quot; } ] end","ref":"readme.html#installation-using-the-wrapper-neuralbridge","title":"Overview - Installation using the wrapper NeuralBridge","type":"extras"},{"doc":"Generic inferred knowledge alias NeuralBridge . { Engine , Rule } engine = Engine . new ( &quot;test&quot; ) rules = [ Rule . new ( id : 1 , given : &quot;&quot;&quot; Person&#39;s name is equal &quot;bob&quot; &quot;&quot;&quot; , then : &quot;&quot;&quot; Person&#39;s age is 23 &quot;&quot;&quot; ) , Rule . new ( id : 2 , given : &quot;&quot;&quot; Person&#39;s name is equal $name Person&#39;s age is equal 23 &quot;&quot;&quot; , then : fn production -&gt; require Logger bindings = Map . get ( production , :bindings ) Logger . info ( inspect ( bindings ) ) end ) ] engine = Engine . add_rules ( engine , rules ) engine = Engine . add_facts ( engine , &quot;Person&#39;s name is \\&quot; bob \\&quot; &quot; ) rule = List . first ( engine . rule_engine . agenda ) engine = Engine . apply_rule ( engine , rule ) Enum . each ( engine . rule_engine . agenda , fn pnode -&gt; Engine . apply_rule ( engine , pnode ) end ) end # will log %{&quot;$name&quot; =&gt; &quot;bob&quot;} Medical diagnosis alias NeuralBridge . { Engine , Rule } engine = Engine . new ( &quot;doctor_AI&quot; ) engine = Engine . add_rules ( engine , [ Rule . new ( id : 1 , given : &quot;&quot;&quot; Patient&#39;s fever is greater 38.5 Patient&#39;s name is equal $name Patient&#39;s generic_weakness is equal &quot;Yes&quot; &quot;&quot;&quot; , then : &quot;&quot;&quot; Patient&#39;s diagnosis is &quot;flu&quot; &quot;&quot;&quot; ) , Rule . new ( id : 2 , given : &quot;&quot;&quot; Patient&#39;s fever is lesser 38.5 Patient&#39;s name is equal $name Patient&#39;s generic_weakness is equal &quot;No&quot; &quot;&quot;&quot; , then : &quot;&quot;&quot; Patient&#39;s diagnosis is &quot;all good&quot; &quot;&quot;&quot; ) ] ) engine = Engine . add_facts ( engine , &quot;&quot;&quot; Patient&#39;s fever is 39 Patient&#39;s name is &quot;Aylon&quot; Patient&#39;s generic_weakness is &quot;Yes&quot; &quot;&quot;&quot; ) ## contains Patient&#39;s diagnnosis [ % _ { action : [ % Retex.Wme { identifier : &quot;Patient&quot; , attribute : &quot;diagnosis&quot; , value : &quot;flu&quot; } ] , bindings : %{ &quot;$name&quot; =&gt; &quot;Aylon&quot; } } ] = engine . rule_engine . agenda","ref":"readme.html#examples-and-usage-with-neuralbridge-a-wrapper-around-retex","title":"Overview - Examples and usage with NeuralBridge (a wrapper around Retex)","type":"extras"},{"doc":"Run mix test","ref":"readme.html#test","title":"Overview - Test","type":"extras"},{"doc":"Run elixir benchmark/rule_chain.exs","ref":"readme.html#benchmark-adding-20k-rules-and-triggering-one","title":"Overview - Benchmark adding 20k rules and triggering one","type":"extras"},{"doc":"Use at your own risk This is just a template for complexer implementations of the described algorithms","ref":"readme.html#warnings","title":"Overview - Warnings","type":"extras"},{"doc":"Rete Retex at ElixirConf EU Retex is available as playground here: https://neuralbridge.fly.dev References: Rete : A Fast Algorithm for the Many Pattern / Many Object Pattern Match Problem * by Charles L . Forgy Department of Computer Science , Carnegie - Mellon University , Pittsburgh , PA 15213 , U.S.A .","ref":"readme.html#resources-and-documentation","title":"Overview - Resources and documentation","type":"extras"}]